/** @file
===========================================================================
MODULE          : CStatusInterface

DESCRIPTIONS    : 

REVISION HISTORY: Version 1.0

COPYRIGHT       : (c)CSIR, Meraka Institute 2007 all rights reserved

RESTRICTIONS	: The information/data/code contained within this file is 
				  the property of CSIR, Meraka Institute and has been 
				  classified as PUBLIC.
===========================================================================
*/
#include "stdafx.h"

#include <DirectShow/Common/CStatusInterface.h>
#include <DirectShow/Common/NotifyCodes.h>

CStatusInterface::CStatusInterface()
: m_sLastError(""),
m_pMediaEventSink(NULL),
m_lFriendlyId(-1)
{}

STDMETHODIMP CStatusInterface::SetLastError( std::string sError, bool bNotifyApplication)
{
	m_sLastError = sError;
	if (bNotifyApplication)
	{
		NotifyApplication(WM_TM_GRAPHNOTIFY, m_lFriendlyId);
	}
	return S_OK;
}

STDMETHODIMP CStatusInterface::GetLastError( std::string& sError )
{
	sError = m_sLastError;
	return S_OK;
}

STDMETHODIMP CStatusInterface::SetMediaEventSink( IMediaEventSink* pEventSink )
{
	m_pMediaEventSink = pEventSink;
	return S_OK;
}

STDMETHODIMP CStatusInterface::SetFriendlyID( long lId )
{
	m_lFriendlyId = lId;
	return S_OK;
}

STDMETHODIMP CStatusInterface::GetFriendlyID( long& lId )
{
	lId = m_lFriendlyId;
	return S_OK;
}

void CStatusInterface::NotifyApplication( long lEventCode, LONG_PTR lEventParam1 )
{
	//Notify sending the friendly ID as a parameter
	if (m_pMediaEventSink)
		m_pMediaEventSink->Notify(lEventCode, m_lFriendlyId, lEventParam1);
}