#include "stdafx.h"
#include "PollingTaskScheduler0.h"

#include <DirectShow/LiveIntegration/directshowdevicesource.h>

PollingTaskScheduler0::PollingTaskScheduler0()
// default time of once per second
: m_uMaxDelayTime(100000)
// default time of once per mili second
//: m_uMaxDelayTime(1000)
{
	
}

void PollingTaskScheduler0::doEventLoop( char* watchVariable )
{
	// Repeatedly loop, handling readble sockets and timed events:
	while (1) {
		if (watchVariable != NULL)
		{
			if (*watchVariable != 0)
			{
				// Break out the while
				break;
			}
		}

		// Check all our sources to see if new data has arrived
		OBSERVABLE_LIST_IT it;
		for (it = m_mDeviceSources.begin(); it != m_mDeviceSources.end(); it++)
		{
			IScheduledTask* pObs = (IScheduledTask*)*it;
			CDirectShowDeviceSource* pSource = (CDirectShowDeviceSource*) pObs;
			if (pSource->hasNewData())
			{
				scheduleDelayedTask(0, pObs->getTask(), *it);
			}
		}
		SingleStep(m_uMaxDelayTime);
	}
}

void PollingTaskScheduler0::registerObservableSource( IScheduledTask* pObservable )
{
	m_mDeviceSources.push_back(pObservable);
}

