/** @file
===========================================================================
MODULE          : PollingTaskScheduler0

DESCRIPTIONS    : 

REVISION HISTORY: Version 1.0

COPYRIGHT       : (c)CSIR, Meraka Institute 2007 all rights reserved

RESTRICTIONS	: The information/data/code contained within this file is 
				  the property of CSIR, Meraka Institute and has been 
				  classified as PUBLIC.
===========================================================================
*/
#ifndef __POLLING_TASK_SCHEDULER_0__H
#define __POLLING_TASK_SCHEDULER_0__H

// STL
#include <vector>
// LiveMedia
#include "BasicUsageEnvironment.hh"
// LiveMedia DirectShow integration
#include "IScheduledTask.h"

// Forward declarations
class CDirectShowDeviceSource;

// Typedefs
typedef std::vector<IScheduledTask*> OBSERVABLE_LIST;
typedef std::vector<IScheduledTask*>::iterator OBSERVABLE_LIST_IT;

class PollingTaskScheduler0 : public BasicTaskScheduler
{
public:
	// Overriding this so that we can control the watch variable
	virtual void doEventLoop(char* watchVariable);

	// measured is in microseconds.
	void setMaximumPollDelay(unsigned uMaxDelayTime) { m_uMaxDelayTime = uMaxDelayTime; } 

	void registerObservableSource(IScheduledTask* pObservable);

protected:

	PollingTaskScheduler0();
	// "m_uMaxDelayTime" is in microseconds.
	unsigned m_uMaxDelayTime;
	 OBSERVABLE_LIST m_mDeviceSources;
};

#endif
