/** @file

MODULE					: PicScalerYUV420PImpl

TAG						: PSYUV420PI

FILE NAME				: PicScalerYUV420PImpl.h

DESCRIPTION				: A YUV420P planar implementation derived from the 
						  general PicScalerBase() class. Scale a YUV420P
						  planar image to the dimensions of another YUV420P
						  planar image.

REVISION HISTORY		:

COPYRIGHT				: (c)CSIR, Meraka Institute 2007 all rights resevered

RESTRICTIONS			: The information/data/code contained within this file is 
						  the property of CSIR, Meraka Institute and has been 
						  classified as PUBLIC.
===========================================================================
*/
#ifndef _PICSCALERYUV420PIMPL_H
#define _PICSCALERYUV420PIMPL_H

#pragma once

#include "PicScalerBase.h"

#ifdef _BUILD_FOR_SHORT
typedef short scaleType;
#else
typedef char scaleType ;
#endif

/*
===========================================================================
  Class definition.
===========================================================================
*/
class PicScalerYUV420PImpl: public PicScalerBase
{
public:
	// Construction and destruction.
	PicScalerYUV420PImpl(void) { }
	PicScalerYUV420PImpl(int widthOut, int heightOut, int widthIn, int heightIn): PicScalerBase(widthOut,heightOut,widthIn,heightIn) { }
	virtual ~PicScalerYUV420PImpl(void) {}

	// Interface.
	int Scale(void* pOutImg, void* pInImg);

};//end PicScalerYUV420PImpl.


#endif	// _PICSCALERYUV420PIMPL_H
