/** @file

MODULE				: RealRGB32toYUV420Converter

TAG					: RRGB32YUVC

FILE NAME			: RealRGB32toYUV420Converter.h

DESCRIPTION			: Double precision floating point RGB 32 bit to YUV420 colour 
					  convertion derived from the RGBtoYUV420Converter base class.
					  Use this implementation as the reference.

REVISION HISTORY	:

COPYRIGHT			: (c)CSIR, Meraka Institute 2007 all rights reserved

RESTRICTIONS		: The information/data/code contained within this file is 
					  the property of CSIR, Meraka Institute and has been 
					  classified as PUBLIC.
===========================================================================
*/
#ifndef _REALRGB32TOYUV420CONVERTER_H
#define _REALRGB32TOYUV420CONVERTER_H

#pragma once

#include "RGBtoYUV420Converter.h"

/*
===========================================================================
  Class definition.
===========================================================================
*/
class RealRGB32toYUV420Converter: public RGBtoYUV420Converter
{
public:
	// Construction and destruction.
	RealRGB32toYUV420Converter(void) { }
	RealRGB32toYUV420Converter(int width, int height): RGBtoYUV420Converter(width,height) { }
	virtual ~RealRGB32toYUV420Converter(void) {}

	// Interface.
	void Convert(void* pRgb, void* pY, void* pU, void* pV);

};//end RealRGB32toYUV420Converter.


#endif //_REALRGB32TOYUV420CONVERTER_H
